*//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*// Author:  Michael Drozdov, ICS Soft, Perm, Russia 
*// My Page: http://vfpdev.narod.ru/ 
*// Date:    12/19/2005
*//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#DEFINE COMATTRIB_READONLY			0x100000
#DEFINE BSF_IGNORECURRENTTASK		0x00000002
#define BSM_APPLICATIONS			0x00000008
#DEFINE FORMAT_MESSAGE_FROM_SYSTEM	0x00001000

#DEFINE LANG_RUS_LOC	.T.
#IF LANG_RUS_LOC
	#DEFINE ERR_CODE_LOC			" : "
	#DEFINE ERR_DESCRIPT_LOC		": "
	#DEFINE ERR_SOURCE_LOC			": "
	#DEFINE ERR_METHOD_LOC			" : "
	#DEFINE ERR_LINE_LOC			" : "
	#DEFINE ERR_CLASS_LOC			" : "
	#DEFINE ERR_LIB_LOC				" : "
#ELSE
	#DEFINE ERR_CODE_LOC			"Error number: "
	#DEFINE ERR_DESCRIPT_LOC		"Description: "
	#DEFINE ERR_SOURCE_LOC			"Source: "
	#DEFINE ERR_METHOD_LOC			" Method: "
	#DEFINE ERR_LINE_LOC			" Line: "
	#DEFINE ERR_CLASS_LOC			" Class: "
	#DEFINE ERR_LIB_LOC				" Library: "
#ENDIF

#DEFINE CRLF			CHR(13) + CHR(10)
#DEFINE ERR_CHRSEP		", "


DEFINE CLASS MyCls as Session OLEPUBLIC
	PROTECTED oFrm
	oFrm = NULL
	nCurBackColor = 0
	nCustIdMsg = 0
	cCustNmMsg = ""
	
	PROCEDURE Init()
		DECLARE INTEGER SetForegroundWindow IN User32.dll as WinAPI_SetForegroundWindow ;
    		LONG hWnd
		DECLARE LONG RegisterWindowMessage IN User32.dll AS WinAPI_RegisterWindowMessage ;
			STRING @ lpString
		DECLARE LONG BroadcastSystemMessage IN User32.dll AS WinAPI_BroadcastSystemMessage ;
			LONG dwFlags ;
			,LONG @ lpdwRecipients ;
   			,INTEGER uiMessage ;
			,LONG wParam ;
			,LONG lParam
		DECLARE INTEGER PostMessage IN User32.dll AS WinAPI_PostMessage ;
			LONG hWnd ;
			,INTEGER Msg ;
			,LONG wParam ;
			,LONG lParam
		DECLARE LONG FormatMessage IN Kernel32.dll AS WinAPI_FormatMessage ;
			LONG dwFlags ;
			,STRING @ lpSource ;
			,LONG dwMessageId ;
			,LONG dwLanguageId ;
			,STRING @ lpBuffer ;
			,LONG nSize ;
		  	,LONG Arguments
		DECLARE LONG GetLastError IN Kernel32.dll AS WinAPI_GetLastError
		
		LOCAL lcCustNmMsg as String, lnCustIDMsg as Long 
		lcCustNmMsg = SYS(2015)   
		lnCustIDMsg = WinAPI_RegisterWindowMessage(@lcCustNmMsg)
		IF lnCustIDMsg = 0
			LOCAL lnCode as Long 
			lnCode = WinAPI_GetLastError()
			this.ShowWin32Err(lnCode)
			CLEAR DLLS
			RETURN .F.  
		ENDIF
		WITH this
			.cCustNmMsg = lcCustNmMsg
			.nCustIDMsg = lnCustIDMsg
		ENDWITH	
		SYS(2339, 1)
		IF INLIST(Application.StartMode, 0, 4)
			SYS(2335, 0)
		ENDIF
	ENDPROC


	PROCEDURE ShowForm() as Boolean HELPSTRING "Create and show form. Return true if successful, otherwise false."
		WITH this
			IF VARTYPE(.oFrm) # 'O'
				.oFrm = CREATEOBJECT("MyForm", this)
				IF VARTYPE(.oFrm) # 'O'
					RETURN .F.
				ENDIF
			ENDIF
			.oFrm.Show()
			.nCurBackColor = .oFrm.BackColor
			WITH .oFrm
				WinAPI_SetForegroundWindow(IIF(.ShowWindow = 2, SYS(2327, SYS(2325, SYS(2326, .hWnd))), .hWnd))
			ENDWITH	
		ENDWITH
	ENDPROC


	PROCEDURE ReleaseForm() as Boolean HELPSTRING "Release form. Return true if successful, otherwise false."
		WITH this
			IF VARTYPE(.oFrm) = 'O'
				.oFrm.Release()
				.oFrm = NULL
				RETURN .T.
			ENDIF
		ENDWITH
		RETURN .F.
	ENDPROC


	PROCEDURE nCurBackColor_Assign
		LPARAMETERS tnNewCurBackColor
		IF VARTYPE(m.tnNewCurBackColor) # 'N'
			RETURN
		ENDIF
		WITH this
			IF VARTYPE(.oFrm) = 'O'
				*
				*-- Get real BackColor property value from oFrm object
				*-- and reset nCurBackColor property value in this class
				.nCurBackColor = .oFrm.BackColor
				*
				*-- Post BroadcastSystemMessage to application 
				*-- about BackColor changed
				LOCAL lnCode as Long, lnRecipients as Long;
					,lnCustIDMsg as Long, lnBackColor as Long 
				lnRecipients = BSM_APPLICATIONS
				lnCustIDMsg = .nCustIDMsg
				lnBackColor = .nCurBackColor
				lnCode = WinAPI_BroadcastSystemMessage( ;
					BSF_IGNORECURRENTTASK, @lnRecipients ;
					,lnCustIDMsg, 1, lnBackColor)
				IF lnCode <= 0
					lnCode = WinAPI_GetLastError()
					this.ShowWin32Err(lnCode)
				ENDIF
			ENDIF
		ENDWITH
	ENDPROC


	PROCEDURE Destroy()
		this.ReleaseForm()
		CLEAR DLLS  
	ENDPROC

	PROCEDURE Error(nError, cMethod, nLine)
		LOCAL ARRAY laErr[1]
		=AERROR(laErr)
		LOCAL lcExceptionSource as String
		lcExceptionSource = ''
		IF !EMPTY(cMethod)
			lcExceptionSource = lcExceptionSource + ERR_METHOD_LOC + cMethod
		ENDIF
		IF !EMPTY(nLine)
			lcExceptionSource = lcExceptionSource + ERR_CHRSEP + ERR_LINE_LOC + LTRIM(TRANSFORM(nLine))
		ENDIF
		IF !EMPTY(this.Class)
			lcExceptionSource = lcExceptionSource + ERR_CHRSEP + ERR_CLASS_LOC + this.Class
		ENDIF
		IF !EMPTY(this.ClassLibrary)
			lcExceptionSource = lcExceptionSource + ERR_CHRSEP + ERR_LIB_LOC + this.ClassLibrary
		ENDIF
		this.ReleaseForm()
		IF !INLIST(Application.StartMode, 0, 4) 
			CLOSE TABLES ALL 
			COMRETURNERROR(lcExceptionSource, laErr[2])
		ELSE
			LOCAL lcErrMsg as String
			lcErrMsg = ''
			IF !EMPTY(laErr[1])
				lcErrMsg = ERR_CODE_LOC + LTRIM(TRANSFORM(nLine))
			ENDIF
			IF !EMPTY(laErr[2])
				lcErrMsg = lcErrMsg + CRLF + ERR_DESCRIPT_LOC + laErr[2]
			ENDIF
			IF !EMPTY(lcExceptionSource)
				lcErrMsg = lcErrMsg + CRLF + ERR_SOURCE_LOC + lcExceptionSource
			ENDIF
			= MESSAGEBOX(lcErrMsg, 16, _SCREEN.Caption) 
		ENDIF	
	ENDPROC

	PROTECTED PROCEDURE GetWin32ErrMsg(tnCode as Long) as String 
		IF VARTYPE(tnCode) # 'N'
			tnCode = 0
		ENDIF
		LOCAL lcMsg as String
		lcMsg = '' 
		IF tnCode <> 0
			LOCAL lnLen as Number 
			lcMsg = REPLICATE(CHR(0), 256*4)
			lnLen = WinAPI_FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM ;
				,NULL ,tnCode, 0, @lcMsg, LENC(lcMsg), 0)
			IF lnLen > 0 AND VARTYPE(lcMsg) = 'C'
				lcMsg = LEFTC(lcMsg, lnLen - 2)
			ELSE
				lcMsg = ''
			ENDIF
		ENDIF
		RETURN lcMsg		
	ENDPROC


	PROTECTED PROCEDURE ShowWin32Err(tnCode as Long) as VOID 
		LOCAL lcMsg as String
		lcMsg = this.GetWin32ErrMsg(tnCode)
		IF !EMPTY(lcMsg)
			IF !INLIST(Application.StartMode, 0, 4) 
				CLOSE TABLES ALL 
				COMRETURNERROR('Win32Error', lcMsg)
			ELSE
				MESSAGEBOX(lcMsg,16, 'Win32Error')
			ENDIF
		ENDIF
	ENDPROC


	DIMENSION nCurBackColor_COMATTRIB[4]
	nCurBackColor_COMATTRIB[1] = COMATTRIB_READONLY
	nCurBackColor_COMATTRIB[2] = "The current backcolor propery value in form"
	nCurBackColor_COMATTRIB[3] = "nCurBackColor"
	nCurBackColor_COMATTRIB[4] = "Long"

	DIMENSION nCustIDMsg_COMATTRIB[4]
	nCustIDMsg_COMATTRIB[1] = COMATTRIB_READONLY
	nCustIDMsg_COMATTRIB[2] = "The customer message identifier for communicating between two cooperating applications."
	nCustIDMsg_COMATTRIB[3] = "nCustIDMsg"
	nCustIDMsg_COMATTRIB[4] = "Long"

	DIMENSION cCustNmMsg_COMATTRIB[4]
	cCustNmMsg_COMATTRIB[1] = COMATTRIB_READONLY
	cCustNmMsg_COMATTRIB[2] = "The customer message name for communicating between two cooperating applications."
	cCustNmMsg_COMATTRIB[3] = "cCustNmMsg"
	cCustNmMsg_COMATTRIB[4] = "String"

ENDDEFINE


DEFINE CLASS MyForm as Form
	ShowWindow = 2
	Closable = .F.
	HalfHeightCaption = .T.
	Caption = "Test timer control in form (server)"
	Name = "MyForm"
	DIMENSION anBackColors[1,1] as Number
	nCurBackColor = 0
	nMaxBackColor = 0
	PROTECTED oClsSes
	oClsSes = NULL


	ADD OBJECT timer1 AS timer WITH ;
		Top = 0, ;
		Left = 0, ;
		Height = 24, ;
		Width = 25, ;
		Interval = 2500, ;
		Name = "Timer1"


	PROCEDURE Load
		WITH this
			DIMENSION .anBackColors[3] as Number
			.anBackColors[1] = RGB(255, 0, 0)
			.anBackColors[2] = RGB(0, 255, 0)
			.anBackColors[3] = RGB(0, 0, 255)
			.nCurBackColor = 0
			.nMaxBackColor = ALEN(.anBackColors)
		ENDWITH
	ENDPROC


	PROCEDURE Init(toClsSes)
		WITH this
			.oClsSes = toClsSes && Save reference to MyCls object
			.timer1.Timer()
		ENDWITH
	ENDPROC


	PROCEDURE Destroy
		this.oClsSes = NULL
	ENDPROC

	PROCEDURE Error(nError, cMethod, nLine)
		IF VARTYPE(this.oClsSes) = 'O'
			this.oClsSes.Error(nError, cMethod, nLine)
		ENDIF
	ENDPROC

	PROCEDURE timer1.Timer
		IF TYPE('this.Parent.anBackColors[1]') = 'U'
			RETURN
		ENDIF
		LOCAL lnCurBackColor as Number
		WITH this.Parent
			lnCurBackColor = .nCurBackColor + 1
			IF lnCurBackColor > .nMaxBackColor
				lnCurBackColor = 1
			ENDIF
			.BackColor = .anBackColors[lnCurBackColor]
			.nCurBackColor = lnCurBackColor
		ENDWITH
	ENDPROC


	PROCEDURE nCurBackColor_Assign
		LPARAMETERS tnNewCurBackColor
		IF VARTYPE(m.tnNewCurBackColor) # 'N'
			RETURN
		ENDIF
		*
		*-- Reset nCurBackColor proprty value in this object
		this.nCurBackColor = m.tnNewCurBackColor
		*
		*-- Reset nCurBackColor proprty value in MyCls object
		IF VARTYPE(this.oClsSes) = 'O'
			this.oClsSes.nCurBackColor = this.nCurBackColor
		ENDIF
	ENDPROC

ENDDEFINE
